{$APPTYPE GUI}
program game2048;{code by ax_pokl}
uses windows,display;

//function ImmGetVirtualKey(hw:HWND):UINT;external 'imm32.dll';

const maxlen=500;
var len:real;szm:real=0.1;

const maxsize=64;
const minsize=2;
var size:shortint;
var bd:array[0..maxsize+1,0..maxsize+1]of shortint;

var rule:shortint;
{$I 2048.inc}

var clbg,clfg,clg:longword;

var i,j,k,l,m,n:longint;

type tsm=record x1,x2,y1,y2,val:shortint;end;
var bdk:array[1..maxsize*maxsize]of tsm;
var smid:longint;

procedure sm(x1,y1,x2,y2,val:shortint);
begin
smid:=smid+1;
bdk[smid].x1:=x1;
bdk[smid].x2:=x2;
bdk[smid].y1:=y1;
bdk[smid].y2:=y2;
bdk[smid].val:=val;
end;

var winb:boolean;
var spd:longint;
    spn:longint;
var fw,fh:real;
    fl:shortint;

procedure clearbd();
begin
bar(0,0,maxlen,maxlen,clg,clg);
end;

procedure restart(rl,sz:shortint);
begin
winb:=false;
rule:=rl;
size:=sz;
if size<minsize then size:=minsize;
if size>maxsize then size:=maxsize;
len:=maxlen/size;
settitle(rules[rule]+
         ' --- join the numbers and get to the '+
         rulest[rule,rulen[rule]]+' tile!');
smid:=-1;
clearbd();
for i:=1 to size do
  for j:=1 to size do
    bd[i,j]:=0;
end;

var nx,ny,nv:shortint;

procedure new;
begin
smid:=0;
spn:=2048 div size;
k:=0;
for i:=1 to size do
  for j:=1 to size do
    if bd[i,j]=0 then k:=k+1;
k:=random(k);
for i:=1 to size do
  for j:=1 to size do
    if bd[i,j]=0 then
      begin
      if k=0 then begin nx:=i;ny:=j;end;
      k:=k-1;
      end;
case rule of
  4:nv:=1;
  7:nv:=32-round(sqrt(random(961)+1));
  else nv:=(random(10)+11) div 10;
  end;
if rule=9 then nv:=nv+random(2)*12;
if not(winb) then bd[nx,ny]:=nv;
end;

var nomerge:boolean;

function merge(val1,val2:shortint):shortint;
begin
merge:=0;
case rule of
  5:begin
    if abs(val1-val2)=1 then merge:=max(val1,val2)+1;
    if (val1=1) and (val2=1) then merge:=2;
    end;
  6:begin
    if val1=val2 then merge:=val1+1 else merge:=0;
    if (val1=1) and (val2=2) then merge:=3;
    if (val1=2) and (val2=1) then merge:=3;
    if (val1=2) and (val2=2) then merge:=0;
    end;
  9:begin
    if val1=val2 then merge:=val1+1 else merge:=0;
    if abs(val1-val2)=12 then merge:=25;
    if (val1=12) and (val2=12) then merge:=0;
    if (val1=24) and (val2=24) then merge:=0;
    if max(val1,val2)=25 then merge:=min(val1,val2);
    end;
  else if val1=val2 then merge:=val1+1 else merge:=0;
  end;
if val1=0 then merge:=0;
if val2=0 then merge:=0;
if merge=rulen[rule] then winb:=true;
end;

procedure move(dir:shortint);
begin
case dir of
  1:begin
    for j:=1 to size do
      begin
      l:=0;
      nomerge:=false;
      for i:=1 to size do
        if bd[i,j]<>0 then
          begin
          if (merge(bd[i,j],bd[l,j])=0) or nomerge then
            begin
            l:=l+1;
            bd[l,j]:=bd[i,j];
            nomerge:=false;
            end
          else
            begin
            bd[l,j]:=merge(bd[i,j],bd[l,j]);
            nomerge:=true;
            end;
          if i<>l then begin sm(i,j,l,j,bd[i,j]);bd[i,j]:=0;end;
          end;
      end;
    end;
  2:begin
    for i:=size downto 1 do
      begin
      l:=0;
      nomerge:=false;
      for j:=1 to size do
        if bd[i,j]<>0 then
          begin
          if (merge(bd[i,j],bd[i,l])=0) or nomerge then
            begin
            l:=l+1;
            bd[i,l]:=bd[i,j];
            nomerge:=false;
            end
          else
            begin
            bd[i,l]:=merge(bd[i,j],bd[i,l]);
            nomerge:=true;
            end;
          if j<>l then begin sm(i,j,i,l,bd[i,j]);bd[i,j]:=0;end;
          end;
      end;
    end;
  3:begin
    for j:=size downto 1 do
      begin
      l:=size+1;
      nomerge:=false;
      for i:=size downto 1 do
        if bd[i,j]<>0 then
          begin
          if (merge(bd[i,j],bd[l,j])=0) or nomerge then
            begin
            l:=l-1;
            bd[l,j]:=bd[i,j];
            nomerge:=false;
            end
          else
            begin
            bd[l,j]:=merge(bd[i,j],bd[l,j]);
            nomerge:=true;
            end;
          if i<>l then begin sm(i,j,l,j,bd[i,j]);bd[i,j]:=0;end;
          end;
      end;
    end;
  4:begin
    for i:=1 to size do
      begin
      l:=size+1;
      nomerge:=false;
      for j:=size downto 1 do
        if bd[i,j]<>0 then
          begin
          if (merge(bd[i,j],bd[i,l])=0) or nomerge then
            begin
            l:=l-1;
            bd[i,l]:=bd[i,j];
            nomerge:=false;
            end
          else
            begin
            bd[i,l]:=merge(bd[i,j],bd[i,l]);
            nomerge:=true;
            end;
          if j<>l then begin sm(i,j,i,l,bd[i,j]);bd[i,j]:=0;end;
          end;
      end;
    end;
  end;
end;

procedure drawk(x,y:real;val:shortint;zm:real);
begin
case val of
  -1:clbg:=clg;
  00:clbg:=$B3C0CC;
  01:clbg:=$DAE4EE;
  02:clbg:=$C8E0ED;
  03:clbg:=$79B1F2;
  04:clbg:=$6395F5;
  05:clbg:=$5F7CF6;
  06:clbg:=$3B5EF6;
  07:clbg:=$72CFED;
  08:clbg:=$61CCED;
  09:clbg:=$50C8ED;
  10:clbg:=$3FC5ED;
  11:clbg:=$2EC2ED;
  12:clbg:=$AB84B7;
  13:clbg:=$A86CAE;
  14:clbg:=$A660AA;
  15:clbg:=$A453A6;
  16:clbg:=$A449A3;
  17:clbg:=$C17776;
  18:clbg:=$C46B68;
  19:clbg:=$C7605B;
  20:clbg:=$C9544D;
  21:clbg:=$CC483F;
  22:clbg:=$100D6B;
  23:clbg:=$0E0B5F;
  24:clbg:=$0D0A53;
  25:clbg:=$0B0847;
  26:clbg:=$09073B;
  27:clbg:=$07062F;
  28:clbg:=$050424;
  29:clbg:=$040318;
  30:clbg:=$02010C;
  31:clbg:=$000000;
  else clbg:=$241CED;
  end;
case val of
  -1:clfg:=clg;
  0:clfg:=$B3C0CC;
  1:clfg:=$656E77;
  2:clfg:=$656E77;
  else clfg:=$F2F6F9;
  end;
bar(round((x-1+zm)*len),round((y-1+zm)*len),round(len*(1-2*zm)),round(len*(1-2*zm)),clbg);
if val>0 then
  begin
  fl:=length(rulest[rule,val]);
  if fl=0 then fl:=1;
  fw:=len*(1-szm*3)/fl*(1-zm*2)/(1-szm*2);
  if fw>len*(1-szm*2)/3*(1-zm*2)/(1-szm*2) then
    fw:=len*(1-szm*2)/3*(1-zm*2)/(1-szm*2);
  if fw<1 then fw:=1;
  fh:=fw*2.25;
  setfontsize(round(fw),round(fh));
  drawtextxy(rulest[rule,val],round((x-0.5)*len-fw*fl/2),round((y-0.5)*len-fh/2),clfg);
  end;
end;

procedure drawnew();
begin
for m:=1 to spn do
  drawk(nx,ny,nv,0.5-(0.5-szm)*m/spn);
end;

procedure drawbd();
begin
for i:=1 to size do
  for j:=1 to size do
    drawk(i,j,bd[i,j],szm);
end;

procedure drawmove();
begin
spd:=2048 div (smid+2);
for m:=1 to spd do
  begin
  n:=m-1;
  for k:=1 to smid do
    with bdk[k] do
      begin
      drawk((x1*(1-n/spd)+x2*(n/spd)),(y1*(1-n/spd)+y2*(n/spd)),-1,1);
      if x2>x1 then drawk(trunc(x1*(1-n/spd)+x2*(n/spd)+0.001),y1*(1-n/spd)+y2*(n/spd),0,szm);
      if x1>x2 then drawk(trunc(x1*(1-n/spd)+x2*(n/spd)+0.999),y1*(1-n/spd)+y2*(n/spd),0,szm);
      if y2>y1 then drawk(x1*(1-n/spd)+x2*(n/spd),trunc(y1*(1-n/spd)+y2*(n/spd)+0.001),0,szm);
      if y1>y2 then drawk(x1*(1-n/spd)+x2*(n/spd),trunc(y1*(1-n/spd)+y2*(n/spd)+0.999),0,szm);
      drawk((x1*(1-m/spd)+x2*(m/spd)),(y1*(1-m/spd)+y2*(m/spd)),val,szm);
      end;
  end;
end;

var key:byte;

begin
randomize;
clg:=$A0ADBB;
createwin(maxlen,maxlen,clg,clg);
setfontname('Consolas');
setfresh(1);
restart(1,4);
repeat
if (smid<>0) then
  begin
  drawbd();
  new();
  if not(winb) then drawnew();
  end;
repeat
nextmsg();
if ismsg(15) then
  begin
  clearbd();
  drawbd();
  end;
until iskey();
key:=getkey();
case key of
  k_left:move(1);
  k_up:move(2);
  k_right:move(3);
  k_down:move(4);
  k_space:restart(rule,size);
  k_return:restart(rule,size);
  k_escape:halt();
  k_back:smid:=-1;
  107:restart(rule,size+1);
  108:restart(rule,size+0);
  109:restart(rule,size-1);
  187:restart(rule,size+1);
  189:restart(rule,size-1);
  229:begin setfontsize(9,20);
      drawtextxy('IME deceted. Please close the Input Method software!',0,0,red,yellow);end;
  end;
if (key>48) and (key<=57) then restart(key-48,size);
if (key>96) and (key<=105) then restart(key-96,size);
if smid>0 then drawmove();
until false;
end.
